#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>
#include <string>
#include <cstring>
#include <fmi2Functions.h>
#include <fmi2FunctionTypes.h>
#include <iostream>
#include <ctime>
#include <jni.h>
#include <fstream> 
#include <chrono>
using namespace std;

int main(int argc, char **argv) {

    int ret = EXIT_SUCCESS;
    fmi2Real tstart = 0.0;
    fmi2Real tcur = tstart;
    fmi2Real hstep = 0.1;
    fmi2Real tend = 300.0;
    void *handle_p, *handle_c, *handle_m;
  
    fmi2InstantiateTYPE* (fmi2InstantiateController);
    fmi2EnterInitializationModeTYPE* (fmi2EnterInitializationModeController);
    fmi2ExitInitializationModeTYPE* (fmi2ExitInitializationModeController);
    fmi2SetRealTYPE* (fmi2SetRealController);
    fmi2GetRealTYPE* (fmi2GetRealController);
    fmi2DoStepTYPE* (fmi2DoStepController);
    void (*set_inverted_map_controller)(int,string);


    fmi2InstantiateTYPE* (fmi2InstantiatePlant);
    fmi2EnterInitializationModeTYPE* (fmi2EnterInitializationModePlant);
    fmi2ExitInitializationModeTYPE* (fmi2ExitInitializationModePlant);
    fmi2SetRealTYPE* (fmi2SetRealPlant);
    fmi2GetRealTYPE* (fmi2GetRealPlant);
    fmi2DoStepTYPE* (fmi2DoStepPlant);
    void (*set_inverted_map_plant)(int,string);

    fmi2InstantiateTYPE* (fmi2InstantiateMonitor);
    fmi2EnterInitializationModeTYPE* (fmi2EnterInitializationModeMonitor);
    fmi2ExitInitializationModeTYPE* (fmi2ExitInitializationModeMonitor);
    fmi2SetIntegerTYPE* (fmi2SetIntegerMonitor);
    fmi2GetIntegerTYPE* (fmi2GetIntegerMonitor);
    fmi2DoStepTYPE* (fmi2DoStepMonitor);

    char *error;
    handle_c = dlopen ("controller/binaries/linux64/controller.so", RTLD_LAZY);
    if (!handle_c) {
        fprintf (stderr, "%s\n", dlerror());
        exit(1);
    }
    dlerror();    /* Clear any existing error */
   
    handle_p = dlopen ("plant/binaries/linux64/plant.so", RTLD_LAZY);
    if (!handle_p) {
        fprintf (stderr, "%s\n", dlerror());
        exit(1);
    }
    dlerror();    /* Clear any existing error */

    handle_m = dlopen ("monitor/binaries/linux64/monitor.so", RTLD_LAZY);
    if (!handle_m) {
        fprintf (stderr, "%s\n", dlerror());
        exit(1);
    }
    dlerror();    /* Clear any existing error */
    
    fmi2InstantiateController = (fmi2InstantiateTYPE*) dlsym(handle_c, "fmi2Instantiate");
    fmi2EnterInitializationModeController = (fmi2EnterInitializationModeTYPE*) dlsym(handle_c, "fmi2EnterInitializationMode");
    fmi2ExitInitializationModeController = (fmi2ExitInitializationModeTYPE*) dlsym(handle_c, "fmi2ExitInitializationMode");
    fmi2SetRealController = (fmi2SetRealTYPE*) dlsym(handle_c, "fmi2SetReal");
    fmi2GetRealController = (fmi2GetRealTYPE*) dlsym(handle_c, "fmi2GetReal");
    fmi2DoStepController = (fmi2DoStepTYPE*) dlsym(handle_c, "fmi2DoStep");
    set_inverted_map_controller = (void (*)(int, std::string)) dlsym(handle_c, "set_inverted_map");


    fmi2InstantiatePlant = (fmi2InstantiateTYPE*) dlsym(handle_p, "fmi2Instantiate");
    fmi2EnterInitializationModePlant = (fmi2EnterInitializationModeTYPE*) dlsym(handle_p, "fmi2EnterInitializationMode");
    fmi2ExitInitializationModePlant = (fmi2ExitInitializationModeTYPE*) dlsym(handle_p, "fmi2ExitInitializationMode");
    fmi2SetRealPlant = (fmi2SetRealTYPE*) dlsym(handle_p, "fmi2SetReal");
    fmi2GetRealPlant = (fmi2GetRealTYPE*) dlsym(handle_p, "fmi2GetReal");
    fmi2DoStepPlant = (fmi2DoStepTYPE*) dlsym(handle_p, "fmi2DoStep");
    set_inverted_map_plant = (void (*)(int, std::string)) dlsym(handle_p, "set_inverted_map");

    fmi2InstantiateMonitor = (fmi2InstantiateTYPE*) dlsym(handle_m, "fmi2Instantiate");
    fmi2EnterInitializationModeMonitor = (fmi2EnterInitializationModeTYPE*) dlsym(handle_m, "fmi2EnterInitializationMode");
    fmi2ExitInitializationModeMonitor = (fmi2ExitInitializationModeTYPE*) dlsym(handle_m, "fmi2ExitInitializationMode");
    fmi2SetIntegerMonitor = (fmi2SetIntegerTYPE*) dlsym(handle_m, "fmi2SetInteger");
    fmi2GetIntegerMonitor = (fmi2GetIntegerTYPE*) dlsym(handle_m, "fmi2GetInteger");
    fmi2DoStepMonitor = (fmi2DoStepTYPE*) dlsym(handle_m, "fmi2DoStep");
    
    if ((error = dlerror()) != NULL)  {
        fprintf (stderr, "%s\n", error);
        exit(1);
    }

    cout<<"CALL fmi2Instantiate...\n";
    
    fmi2Component c_controller = (*fmi2InstantiateController)("controllerModel", fmi2CoSimulation , "controllerModel", "resource/location", NULL, true, true);
    
    (*set_inverted_map_controller)(100, "ROOT.environment._id__inputIndex");
    //(*set_inverted_map)(101, "ROOT.environment._id__time");
    (*set_inverted_map_controller)(101, "ROOT.camera._id__inputIndex");
    (*set_inverted_map_controller)(102, "ROOT.perception._id__result_buffer");
    (*set_inverted_map_controller)(103, "ROOT.perception._id__inputIndex");
    (*set_inverted_map_controller)(104, "ROOT.perception._id__result");
    (*set_inverted_map_controller)(105, "ROOT.controller._id__speed");
    (*set_inverted_map_controller)(106, "ROOT.controller._id__speedLimit");
    (*set_inverted_map_controller)(107, "ROOT.controller._id__deltaSpeed");
    (*set_inverted_map_controller)(108, "ROOT.controller._id__zero");
    
    fmi2Component c_plant = (*fmi2InstantiatePlant)("plantModel", fmi2CoSimulation , "plantModel", "resource/location", NULL, true, true);
    
    (*set_inverted_map_plant)(109, "ROOT.brake._id__deltaSpeed");
    (*set_inverted_map_plant)(110, "ROOT.throttle._id__deltaSpeed");
    (*set_inverted_map_plant)(111, "ROOT.speedSensor._id__speed");
    (*set_inverted_map_plant)(112, "ROOT.speedSensor._id__deltaSpeed");
    
    fmi2Component c_monitor = (*fmi2InstantiateMonitor)("monitorModel", fmi2CoSimulation , "monitorModel", "resource/location", NULL, true, true);

    const unsigned int vr_controller[] = {100,101,102,103,104,105,106,107,108};
    const unsigned int vr_plant[] = {109,110,111,112};
    const unsigned int vr_monitor[] = {555,556};

    fmi2Real values_controller[] = {1,0,0,0,0,100,110,0,0};
    fmi2Real values_plant[] = {0,0,100,0};
    fmi2Integer values_monitor[] = {650000,666666};

    cout<<"CALL fmi2SetReal of controller...\n";
    (*fmi2SetRealController)(c_controller, vr_controller, 9, values_controller);
    
    cout<<"CALL fmi2SetReal of plant...\n";
    (*fmi2SetRealPlant)(c_plant, vr_plant, 4, values_plant);

    cout<<"CALL fmi2SetInteger of monitor...\n";
    (*fmi2SetIntegerMonitor)(c_monitor, vr_monitor, 2, values_monitor);

    cout<<"CALL fmi2EnterInitializationMode...\n";
    (*fmi2EnterInitializationModeController)(c_controller);
    (*fmi2EnterInitializationModePlant)(c_plant);
    (*fmi2EnterInitializationModeMonitor)(c_monitor);

    cout<<"CALL fmi2ExitInitializationMode...\n";
    (*fmi2ExitInitializationModeController)(c_controller);
    (*fmi2ExitInitializationModePlant)(c_plant);
    (*fmi2ExitInitializationModeMonitor)(c_monitor);
    
    tcur = tstart;
    fmi2Real result_buffer = 0;

    std::ofstream cent_times ("decentralized_times.txt");
    std::ofstream cent_trace ("decentralized_trace.txt");
    std::ofstream data ("decentralized_data.txt");

    std::chrono::time_point<std::chrono::system_clock> start_while = std::chrono::system_clock::now();
    while(tcur<tend){
        std::chrono::time_point<std::chrono::system_clock> start_iteration = std::chrono::system_clock::now();
        fmi2Boolean newStep = fmi2True;
        fmi2Real val_controller[9];
        fmi2Real val_plant[4];
        fmi2Integer val_monitor[2];

        cout<<"Current time step: "<<tcur<<'\n';
        
        cout<<"CALL controller fmi2DoStep...\n";
        fmi2DoStepController(c_controller, tcur,hstep, newStep);

        cout<<"CALL controller fmi2GetReal...\n";
        fmi2GetRealController(c_controller, vr_controller, 9, val_controller);
    
        cout<<"Speed Limit:"<<val_controller[6]<<endl;
        val_monitor[0] = (int) (val_controller[6] * 1000000);

        /* Synchronization between two fmus - send plant's speed to the controller
        one step after new traffic sign detection
         */

        if( val_controller[2] != result_buffer ) {

            fmi2Real val_plant_speed[1];
            const unsigned int vr_plant_speed[] = {111};
            const unsigned int vr_controller_speed[] = {105};
            cout<<"Send plant's speed to controller\n";
            result_buffer = val_controller[2];
            fmi2GetRealPlant(c_plant, vr_plant_speed, 1, val_plant_speed);
            fmi2SetRealController(c_controller, vr_controller_speed, 1, val_plant_speed);
        }

        /* Synchronization between two fmus - send deltaSpeed speed to the plant's throttle/break
        two steps after new traffic sign detection
         */
        else if ( val_controller[7] > 0) { 
            fmi2Real val_plant_speed[1];
            val_plant_speed[0] = val_controller[7];
            const unsigned int vr_plant_throttle[] = {110};
            fmi2SetRealPlant(c_plant, vr_plant_throttle, 1, val_plant_speed);
             
        }
        else if ( val_controller[7] < 0) {

            fmi2Real val_plant_speed[1];
            val_plant_speed[0] = val_controller[7];
            const unsigned int vr_plant_break[] = {109};
            fmi2SetRealPlant(c_plant, vr_plant_break, 1, val_plant_speed);
           
        }
       
        fmi2DoStepPlant(c_plant, tcur,hstep, newStep);
        fmi2GetRealPlant(c_plant, vr_plant, 4, val_plant);
        cout<<"Speed:"<<val_plant[2]<<endl;
        data<<val_controller[6]<<","<<val_plant[2]<<"\n";

        std::chrono::time_point<std::chrono::system_clock> start_synthesize = std::chrono::system_clock::now();

        /* Fmi2 set in order to alter the monitor values */
        val_monitor[1] = (int) (val_plant[2] * 1000000);
        (*fmi2SetIntegerMonitor)(c_monitor, vr_monitor, 2, val_monitor);

        std::chrono::time_point<std::chrono::system_clock> end_synthesize = std::chrono::system_clock::now();

        std::chrono::time_point<std::chrono::system_clock> start_monitor = std::chrono::system_clock::now();
        /* Call monitor for evaluation */
        fmi2DoStepMonitor(c_monitor, tcur,hstep, newStep);

        std::chrono::time_point<std::chrono::system_clock> end_monitor = std::chrono::system_clock::now();

        tcur += hstep;
        std::chrono::time_point<std::chrono::system_clock> end_iteration = std::chrono::system_clock::now();

       cent_times<<chrono::duration_cast<chrono::duration<float,std::milli>>(end_iteration - start_iteration).count() /*(end_iteration - start_iteration) / (double)(CLOCKS_PER_SEC)*/<< "," 
        << chrono::duration_cast<chrono::duration<float,std::milli>>(end_synthesize - start_synthesize).count() /*(end_synthesize - start_synthesize)/ (double)(CLOCKS_PER_SEC) */<< 
        "," << chrono::duration_cast<chrono::duration<float,std::milli>>(end_monitor - start_monitor).count() /*(end_monitor - start_monitor)/ (double)(CLOCKS_PER_SEC)*/ << '\n';
     }

    std::chrono::time_point<std::chrono::system_clock> end_while = std::chrono::system_clock::now();
    cent_trace<<"Total simulation loop time:" << chrono::duration_cast<chrono::milliseconds>(end_while - start_while).count() /*(end_while - start_while)/ (double)(CLOCKS_PER_SEC)*/<< 
        "," << "Number of iterations: " << tend/hstep << '\n';
        
    cout<<"Simulation finished.\n";
    dlclose(handle_c);
    dlclose(handle_p);
    dlclose(handle_m);
    cent_times.close();
    cent_trace.close();
    data.close();
    return ret;
}
